require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_ATOMIC_H)) {
    eval 'sub _ASM_IA64_ATOMIC_H () {1;}' unless defined(&_ASM_IA64_ATOMIC_H);
    require 'linux/types.ph';
    require 'asm/system.ph';
    eval 'sub ATOMIC_INIT {
        my($i) = @_;
	    eval q((( &atomic_t) { ($i) }));
    }' unless defined(&ATOMIC_INIT);
    eval 'sub atomic_read {
        my($v) = @_;
	    eval q((($v)-> &counter));
    }' unless defined(&atomic_read);
    eval 'sub atomic_set {
        my($v,$i) = @_;
	    eval q(((($v)-> &counter) = ($i)));
    }' unless defined(&atomic_set);
    eval 'sub ia64_atomic_add {
        my($i,$v) = @_;
	    eval q({  &__s32  &old,  &new;  &CMPXCHG_BUGCHECK_DECL  &do {  &CMPXCHG_BUGCHECK($v);  &old =  &atomic_read($v);  &new =  &old + $i; }  &while ( &ia64_cmpxchg(\\"acq\\", $v,  &old,  &old + $i, $sizeof{ &atomic_t}) !=  &old);  &new; });
    }' unless defined(&ia64_atomic_add);
    eval 'sub ia64_atomic_sub {
        my($i,$v) = @_;
	    eval q({  &__s32  &old,  &new;  &CMPXCHG_BUGCHECK_DECL  &do {  &CMPXCHG_BUGCHECK($v);  &old =  &atomic_read($v);  &new =  &old - $i; }  &while ( &ia64_cmpxchg(\\"acq\\", $v,  &old,  &new, $sizeof{ &atomic_t}) !=  &old);  &new; });
    }' unless defined(&ia64_atomic_sub);
    eval 'sub atomic_add_return {
        my($i,$v) = @_;
	    eval q((( &__builtin_constant_p($i)  && ( ($i == 1) || ($i == 4) || ($i == 8) || ($i == 16) || ($i == -1) || ($i == -4) || ($i == -8) || ($i == -16))) ?  &ia64_fetch_and_add($i, ($v)-> &counter) :  &ia64_atomic_add($i, $v)));
    }' unless defined(&atomic_add_return);
    eval 'sub atomic_sub_return {
        my($i,$v) = @_;
	    eval q((( &__builtin_constant_p($i)  && ( ($i == 1) || ($i == 4) || ($i == 8) || ($i == 16) || ($i == -1) || ($i == -4) || ($i == -8) || ($i == -16))) ?  &ia64_fetch_and_add(-($i), ($v)-> &counter) :  &ia64_atomic_sub($i, $v)));
    }' unless defined(&atomic_sub_return);
    eval 'sub atomic_dec_return {
        my($v) = @_;
	    eval q( &atomic_sub_return(1, ($v)));
    }' unless defined(&atomic_dec_return);
    eval 'sub atomic_inc_return {
        my($v) = @_;
	    eval q( &atomic_add_return(1, ($v)));
    }' unless defined(&atomic_inc_return);
    eval 'sub atomic_sub_and_test {
        my($i,$v) = @_;
	    eval q(( &atomic_sub_return(($i), ($v)) == 0));
    }' unless defined(&atomic_sub_and_test);
    eval 'sub atomic_dec_and_test {
        my($v) = @_;
	    eval q(( &atomic_sub_return(1, ($v)) == 0));
    }' unless defined(&atomic_dec_and_test);
    eval 'sub atomic_inc_and_test {
        my($v) = @_;
	    eval q(( &atomic_add_return(1, ($v)) != 0));
    }' unless defined(&atomic_inc_and_test);
    eval 'sub atomic_add {
        my($i,$v) = @_;
	    eval q( &atomic_add_return(($i), ($v)));
    }' unless defined(&atomic_add);
    eval 'sub atomic_sub {
        my($i,$v) = @_;
	    eval q( &atomic_sub_return(($i), ($v)));
    }' unless defined(&atomic_sub);
    eval 'sub atomic_inc {
        my($v) = @_;
	    eval q( &atomic_add(1, ($v)));
    }' unless defined(&atomic_inc);
    eval 'sub atomic_dec {
        my($v) = @_;
	    eval q( &atomic_sub(1, ($v)));
    }' unless defined(&atomic_dec);
    eval 'sub smp_mb__before_atomic_dec () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_atomic_dec);
    eval 'sub smp_mb__after_atomic_dec () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_atomic_dec);
    eval 'sub smp_mb__before_atomic_inc () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_atomic_inc);
    eval 'sub smp_mb__after_atomic_inc () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_atomic_inc);
}
1;
