require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_HW_IRQ_H)) {
    eval 'sub _ASM_IA64_HW_IRQ_H () {1;}' unless defined(&_ASM_IA64_HW_IRQ_H);
    require 'linux/sched.ph';
    require 'linux/types.ph';
    require 'asm/machvec.ph';
    require 'asm/ptrace.ph';
    require 'asm/smp.ph';
    eval 'sub IA64_MIN_VECTORED_IRQ () {16;}' unless defined(&IA64_MIN_VECTORED_IRQ);
    eval 'sub IA64_MAX_VECTORED_IRQ () {255;}' unless defined(&IA64_MAX_VECTORED_IRQ);
    eval 'sub IA64_NUM_VECTORS () {256;}' unless defined(&IA64_NUM_VECTORS);
    eval 'sub IA64_SPURIOUS_INT_VECTOR () {0xf;}' unless defined(&IA64_SPURIOUS_INT_VECTOR);
    eval 'sub IA64_PCE_VECTOR () {0x1e;}' unless defined(&IA64_PCE_VECTOR);
    eval 'sub IA64_CMC_VECTOR () {0x1f;}' unless defined(&IA64_CMC_VECTOR);
    eval 'sub IA64_FIRST_DEVICE_VECTOR () {0x30;}' unless defined(&IA64_FIRST_DEVICE_VECTOR);
    eval 'sub IA64_LAST_DEVICE_VECTOR () {0xe7;}' unless defined(&IA64_LAST_DEVICE_VECTOR);
    eval 'sub IA64_MCA_RENDEZ_VECTOR () {0xe8;}' unless defined(&IA64_MCA_RENDEZ_VECTOR);
    eval 'sub IA64_PERFMON_VECTOR () {0xee;}' unless defined(&IA64_PERFMON_VECTOR);
    eval 'sub IA64_TIMER_VECTOR () {0xef;}' unless defined(&IA64_TIMER_VECTOR);
    eval 'sub IA64_MCA_WAKEUP_VECTOR () {0xf0;}' unless defined(&IA64_MCA_WAKEUP_VECTOR);
    eval 'sub IA64_IPI_RESCHEDULE () {0xfd;}' unless defined(&IA64_IPI_RESCHEDULE);
    eval 'sub IA64_IPI_VECTOR () {0xfe;}' unless defined(&IA64_IPI_VECTOR);
    eval 'sub IA64_IPI_DEFAULT_BASE_ADDR () {0xfee00000;}' unless defined(&IA64_IPI_DEFAULT_BASE_ADDR);
    eval("sub IA64_IPI_DM_INT () { 0x0; }") unless defined(&IA64_IPI_DM_INT);
    eval("sub IA64_IPI_DM_PMI () { 0x2; }") unless defined(&IA64_IPI_DM_PMI);
    eval("sub IA64_IPI_DM_NMI () { 0x4; }") unless defined(&IA64_IPI_DM_NMI);
    eval("sub IA64_IPI_DM_INIT () { 0x5; }") unless defined(&IA64_IPI_DM_INIT);
    eval("sub IA64_IPI_DM_EXTINT () { 0x7; }") unless defined(&IA64_IPI_DM_EXTINT);
    eval 'sub isa_irq_to_vector {
        my($x) = @_;
	    eval q( $isa_irq_to_vector_map[($x)]);
    }' unless defined(&isa_irq_to_vector);
    eval 'sub hw_resend_irq {
        my($h,$vector) = @_;
	    eval q({  &platform_send_ipi( &smp_processor_id(), $vector,  &IA64_IPI_DM_INT, 0); });
    }' unless defined(&hw_resend_irq);
    eval 'sub __ia64_irq_desc {
        my($irq) = @_;
	    eval q({  &_irq_desc + $irq; });
    }' unless defined(&__ia64_irq_desc);
    eval 'sub __ia64_irq_to_vector {
        my($irq) = @_;
	    eval q({ ( &ia64_vector) $irq; });
    }' unless defined(&__ia64_irq_to_vector);
    eval 'sub __ia64_local_vector_to_irq {
        my($vec) = @_;
	    eval q({ $vec; });
    }' unless defined(&__ia64_local_vector_to_irq);
}
1;
