require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_SPINLOCK_H)) {
    eval 'sub _ASM_IA64_SPINLOCK_H () {1;}' unless defined(&_ASM_IA64_SPINLOCK_H);
    require 'linux/kernel.ph';
    require 'asm/system.ph';
    require 'asm/bitops.ph';
    require 'asm/atomic.ph';
    undef(&NEW_LOCK) if defined(&NEW_LOCK);
    if(defined(&NEW_LOCK)) {
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    my($x) = @_;
    	    eval q((($x)-> &lock = 0));
	}' unless defined(&spin_lock_init);
	eval 'sub spin_lock {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&spin_lock);
	eval 'sub spin_trylock {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&spin_trylock);
	eval 'sub spin_is_locked {
	    my($x) = @_;
    	    eval q((($x)-> &lock != 0));
	}' unless defined(&spin_is_locked);
	eval 'sub spin_unlock {
	    my($x) = @_;
    	    eval q( &do {  &barrier(); (( &spinlock_t *) $x)-> &lock = 0;}  &while (0));
	}' unless defined(&spin_unlock);
	eval 'sub spin_unlock_wait {
	    my($x) = @_;
    	    eval q( &do {  &barrier(); }  &while (($x)-> &lock));
	}' unless defined(&spin_unlock_wait);
    } else {
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    my($x) = @_;
    	    eval q((($x)-> &lock = 0));
	}' unless defined(&spin_lock_init);
	eval 'sub spin_lock {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&spin_lock);
	eval 'sub spin_is_locked {
	    my($x) = @_;
    	    eval q((($x)-> &lock != 0));
	}' unless defined(&spin_is_locked);
	eval 'sub spin_unlock {
	    my($x) = @_;
    	    eval q( &do {  &barrier(); (( &spinlock_t *) $x)-> &lock = 0; }  &while (0));
	}' unless defined(&spin_unlock);
	eval 'sub spin_trylock {
	    my($x) = @_;
    	    eval q(( &cmpxchg_acq(($x)-> &lock, 0, 1) == 0));
	}' unless defined(&spin_trylock);
	eval 'sub spin_unlock_wait {
	    my($x) = @_;
    	    eval q( &do {  &barrier(); }  &while (($x)-> &lock));
	}' unless defined(&spin_unlock_wait);
    }
    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0, 0};}' unless defined(&RW_LOCK_UNLOCKED);
    eval 'sub read_lock {
        my($rw) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&read_lock);
    eval 'sub read_unlock {
        my($rw) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&read_unlock);
    eval 'sub write_lock {
        my($rw) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&write_lock);
    eval 'sub write_unlock {
        my($x) = @_;
	    eval q(({ &clear_bit(31, ($x));  &mb();}));
    }' unless defined(&write_unlock);
}
1;
